(function () {
    "use strict";

    angular.module('core').controller('planoAbastecimentoController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$state', '$alert', 'planoAbastecimentoService', 'lookupService'];

    function controller($scope, $timeout, $q, $state, $alert, planoAbastecimentoService, lookupService) {
        $scope.initializeLayout('Plano de Abastecimento');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: null
            }
        };

        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                saveNew: function (action) {

                    debugger
                    if (!$scope.popups.add.data || !$scope.popups.add.data.Filial || !$scope.popups.add.data.Filial.Empresa || !$scope.popups.add.data.Filial.Empresa.ID) {
                        $scope.tools.toastr.error('Necessario selecionar uma filial para criar um plano!');
                        return;
                    }
                    if ($scope.popups.add.PlanoAbastecimento && $scope.popups.add.PlanoAbastecimento.ID) {
                        planoAbastecimentoService
                            .get($scope.popups.add.PlanoAbastecimento)
                            .then(
                                function (response) {
                                    if (response.Status < 0) {
                                        $scope.tools.toastr.error(response.Message, 'Serviço');
                                    } else {
                                        debugger
                                        var itemPlano = response.Data;
                                        if (itemPlano) {
                                            for (var i = 0; i < itemPlano.Itens.length; i++) {

                                                var item = itemPlano.Itens[i];
                                                item.ID = null;
                                                if (!$scope.popups.add.data.Itens) {
                                                    $scope.popups.add.data.Itens = [];
                                                }

                                                $scope.popups.add.data.Itens.push(item);

                                            }
                                            $scope.popups.add.save(action);
                                        }
                                    }
                                },
                                function (_error) {
                                    $scope.state.carregando = false;
                                    $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                                }
                            );
                    }
                    else {
                        $scope.popups.add.save(action);
                    }
                },
                save: function (action) {
                    $scope.state.salvando = true;

                    planoAbastecimentoService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $state.go("state-planos-abastecimento-edit", { id: response.Data.ID });
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                saveAction: {
                    save: 0,
                    saveAndNew: 1,
                    saveAndEdit: 2,
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }
                },
                prepare: function () {
                    planoAbastecimentoService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.add.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ativo = true;
                                }
                            },
                            function (_error) {
                                $scope.popups.add.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                steps: {
                    index: 0,
                    count: 6,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                },
            }
        };

     
        $scope.auxiliar = {
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            planoAbastecimento: {
                lookup: function (chaves) {
                    return $q.when(

                        lookupService
                            .getAllPlanoAbastecimento({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.clearFilter();
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            planoAbastecimentoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            planoAbastecimentoService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.carregandoMais = true;
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            planoAbastecimentoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                        $scope.state.carregandoMais = false;
                    },
                    function (_error) {
                        $scope.state.carregandoMais = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };
        $scope.delete = function (id) {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            planoAbastecimentoService
                .delete(id)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        }
                        $scope.getAll();
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args = {
                chaves: '',
                filtro: {
                    Ativo: null,
                    Codigo: null,
                    Marca: { Codigo: null, Nome: null },
                    Colecao: { Codigo: null, Nome: null },
                    Tipo: { Codigo: null, Nome: null },
                    Grupo: { Codigo: null, Nome: null },
                    Subgrupo: { Codigo: null, Nome: null },
                    Linha: { Codigo: null, Nome: null },
                    Grade: { Codigo: null, Nome: null },
                    Unidade: { Codigo: null, Nome: null },
                    Composicao: { Codigo: null, Nome: null },
                    Fabricacao: {
                        ReferenciaFabricante: null,
                        Fornecedor: { Empresa: { Nome: null } },
                    },
                    Genero: null,
                    CanalVenda: {
                        Loja: null,
                        Franquia: null,
                        LojaVirtual: null,
                        AFV: null,
                        B2B: null,
                    },
                },
                filtroDe: { CadastradoEm: null },
                filtroAte: { CadastradoEm: null },
                filtroEm: [],
                sortExpression: '',
                skip: 0,
                take: 20
            };

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        $scope.toggleView = function () {
            $scope.view.index = $scope.view.index == 0 ? 1 : 0;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();